// ebp-test.c, 64-Bit-Version
//
// Systemprogrammierung, SS 2013
// Hans-Georg Esser

#include <stdio.h>   // printf

#define get_ebp(v) __asm__ ("movq %%rbp, %0" : "=r"(v))

// die ersten sechs Parameter werden bei x64 ueber Register an die
// Funktion weiter geleitet.
// Man muss x und y (7. / 8. Argument) anschauen!
int f (int a1, int a2, int a3, int a4, int a5, int a6, int x, int y) {
  unsigned long a, b;
  
  get_ebp (a);

  printf ("&a  : %p \n",      &a);
  printf ("&b  : %p \n\n",    &b);

  printf ("ebp : 0x%lx \n\n", a);

  x++;
  y++;
  printf ("&x  : %p \n",      &x);
  printf ("&y  : %p \n",      &y);

  return 0;
}

int main () {
  f (1, 2, 3, 4, 5, 6, 12, 24);
}
